//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit2.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm2 *Form2;
#define ZVETSENI 15
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm2::prekresli_ctverecek(int barva,int x,int y) {
        if (barva == 1)
          PaintBox1->Canvas->Brush->Color = clRed;

          PaintBox1->Canvas->Rectangle(x*ZVETSENI,y*ZVETSENI,
                                     (x+1)*ZVETSENI+1,(y+1)*ZVETSENI+1);
          PaintBox1->Canvas->Brush->Color = clWhite;
}

void TForm2::prekresli_obraz(void) {

PaintBox1->Width = ZVETSENI*rX;
PaintBox1->Height = ZVETSENI*rY;

PaintBox1->Canvas->Brush->Color = clWhite;
PaintBox1->Canvas->Rectangle(0,0,PaintBox1->Width,PaintBox1->Height);

for (int i = 0; i < rX; i++) {
        PaintBox1->Canvas->MoveTo(ZVETSENI*i,0);
        PaintBox1->Canvas->LineTo(i*ZVETSENI,rY*ZVETSENI);
}
for (int i = 0; i < rY; i++) {
        PaintBox1->Canvas->MoveTo(0,ZVETSENI*i);
        PaintBox1->Canvas->LineTo(rX*ZVETSENI,i*ZVETSENI);
}

for (int x = 0; x < rX; x++)
    for (int y = 0; y < rY; y++) {
        if (matice[x][y] == 1) {
                prekresli_ctverecek(1,x,y);
                }
    }
}

void __fastcall TForm2::Button3Click(TObject *Sender)
{
Form2->Close();        
}
//---------------------------------------------------------------------------

void __fastcall TForm2::FormActivate(TObject *Sender)
{
  prekresli_obraz();
  Label3->Caption = "Rozmer matice = " + AnsiString(rX) + " * " + AnsiString(rY);        
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button1Click(TObject *Sender)
{
   prekresli_obraz();        
}
//---------------------------------------------------------------------------

void __fastcall TForm2::FormPaint(TObject *Sender)
{
prekresli_obraz();        
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button2Click(TObject *Sender)
{
int k;

k = 0;
for (int j = 0; j < rY; j++)
 for (int i = 0; i <rX; i++)
 {
 U1[k] = matice[i][j];
 k++;
}

for (int i = 0; i < rX*rY; i++)
        for (int j = 0; j < rX*rY; j++)
           if (i != j) {
              Wij[i][j] += U1[i]*U1[j];
           }

for (int i = 0; i < rX; i++)
        for (int j = 0; j < rY; j++)
                matice[i][j] = -1;
prekresli_obraz();

/*Label2->Caption = "";
for (int i = 0; i < rX*rY; i++) {
        for (int j = 0; j < rX*rY; j++)
                Label2->Caption = Label2->Caption + AnsiString(Wij[i][j]) + " ";
        Label2->Caption = Label2->Caption + "\n";
        }
  */
}
//---------------------------------------------------------------------------

void __fastcall TForm2::PaintBox1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
int kdeX = -1,kdeY = -1;
for (int x = 0; x < rX;x++)
   if ((x*ZVETSENI < X) && ((x+1)*ZVETSENI > X)) {
           kdeX = x;
           break;
           }

for (int y = 0; y < rY;y++)
   if ((y*ZVETSENI < Y) && ((y+1)*ZVETSENI > Y)) {
           kdeY = y;
           break;
           }

if ((kdeX < 0) || (kdeY < 0))
        return;

if (Shift.Contains(ssLeft)) {
        matice[kdeX][kdeY] = 1;
        prekresli_ctverecek(1,kdeX,kdeY);
}
else if (Shift.Contains(ssRight)) {
        matice[kdeX][kdeY] = -1;
        prekresli_ctverecek(-1,kdeX,kdeY);
}

}
//---------------------------------------------------------------------------

void __fastcall TForm2::PaintBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
//stejna funkce jako u PaintBox1MouseMove
int kdeX = -1,kdeY = -1;
for (int x = 0; x < rX;x++)
   if ((x*ZVETSENI < X) && ((x+1)*ZVETSENI > X)) {
           kdeX = x;
           break;
           }

for (int y = 0; y < rY;y++)
   if ((y*ZVETSENI < Y) && ((y+1)*ZVETSENI > Y)) {
           kdeY = y;
           break;
           }

if ((kdeX < 0) || (kdeY < 0))
        return;

if (Shift.Contains(ssLeft)) {
        matice[kdeX][kdeY] = 1;
        prekresli_ctverecek(1,kdeX,kdeY);
}
else if (Shift.Contains(ssRight)) {
        matice[kdeX][kdeY] = -1;
        prekresli_ctverecek(-1,kdeX,kdeY);
}

}
//---------------------------------------------------------------------------


void __fastcall TForm2::Button4Click(TObject *Sender)
{
Button1->Enabled = false;
Button2->Enabled = false;
Button4->Enabled = false;
int k;
//--------krok 1 ---------
k = 0;
for (int i = 0; i < rY; i++)
        for (int j = 0; j < rX; j++) {
                U1[k] = matice[j][i];
                k++;
                }
cykl = 0;
Timer1->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Timer1Timer(TObject *Sender)
{
int pom,k;
//---------krok 2 ----------
 Label1->Caption = AnsiString(++cykl);

 for (int i = 0; i < rX*rY; i++) {
          pom = 0;
          for (int j = 0; j < rX*rY; j++)
                  pom += U1[j]*Wij[i][j];
          if (pom <= 0)
                U2[i] = -1;
          else U2[i] = 1;
 }
//----------------graficke znazorneni -------
 k = 0;

  for (int j = 0; j < rY; j++)
        for (int i = 0; i < rX; i++)
          matice[i][j] = U2[k++];
   prekresli_obraz();
 //-------------------------------------------

/*
Label2->Caption = "U1 = ";
for (int i = 0; i < rX*rY; i++)
        Label2->Caption = Label2->Caption + AnsiString(U1[i]) + " ";
Label2->Caption = Label2->Caption + "\nU2 = ";
for (int i = 0; i < rX*rY; i++)
        Label2->Caption = Label2->Caption + AnsiString(U2[i]) + " ";
*/

pom = 0;
 for (int i = 0; i < rX*rY;i++)
   if (U2[i] != U1[i])
        pom = 1;

 for (int i = 0; i <rX*rY; i++)
        U1[i] = U2[i];

if (pom == 0) {
 Timer1->Enabled = false;
 Button1->Enabled = true;
 Button2->Enabled = true;
 Button4->Enabled = true;
 Label1->Caption = Label1->Caption + " Hotovo";
}

}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button5Click(TObject *Sender)
{
for (int i = 0; i < rX; i++)
  for (int j = 0; j < rY; j++)
        matice[i][j] = -1;

prekresli_obraz();
}
//---------------------------------------------------------------------------

void __fastcall TForm2::FormClose(TObject *Sender, TCloseAction &Action)
{
Timer1->Enabled = false;
Button1->Enabled = true;
Button2->Enabled = true;
Button4->Enabled = true;        
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Label3Click(TObject *Sender)
{
 MessageDlg("Program provedl platnou operaci !\nPravdpodobn se nejedn o program firmy Microsoft", mtError, TMsgDlgButtons() << mbOK, 0);        
}
//---------------------------------------------------------------------------

